\name{bdglm.control}
\alias{bdglm.control}
\title{Set control parameters for bdglm functions}
\description{
Auxiliary function used to set and override default control parameters. Used by bdglm.fit, bdglm.lasso and bdglm.groupbridge.
}
\usage{
bdglm.control(epsilon = 1e-08, maxit = 100, trace = FALSE, maxitcg = 100, maxitcd = 100, maxitgb = 2, threshold = 1e-08)
}
\arguments{
  \item{epsilon}{
	tolerance parameter for \code{iteratively reweighted least squares},\code{conjugate gradient},\code{coordinate descent}
	}
  \item{maxit}{
	maximum number of iterations for \code{iteratively reweighted least squares}.
	}
  \item{trace}{
	if set to \code{True} print additional trace.
	}
  \item{maxitcg}{
	maximum number of iterations for \code{conjugate gradient}.
	}
  \item{maxitcd}{
	maximum number of iterations for \code{coordinate descent}.
	}
  \item{maxitgb}{
	maximum number of iterations for \code{group bridge}.
	}
  \item{threshold}{
	threshold to consider the coefficient a zero
	}
}
\details{
}
\value{
NA
}
\references{
}
\author{
Ela Sienkiewicz
}
\note{
}


\seealso{
}
\examples{

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ glm }
